#include <graphics.h>
#include <stdlib.h>
#include <stdio.h>
#include <conio.h>
#include <math.h>
#include <time.h>

#define TOP     40
#define BOTTOM  440
#define LEFT    120
#define RIGHT   520
#define PI      3.141592654

/* ------------------------------------------------------------------------ */
void ResetScreen (void)
/* ------------------------------------------------------------------------ */
{
int gdriver = DETECT, gmode, errorcode;

	initgraph(&gdriver, &gmode, "");
	errorcode = graphresult();
	if (errorcode != grOk)
	{
		printf("Graphics error: %s\n", grapherrormsg(errorcode));
		printf("Press any key to halt:");
		getch();
		exit(1);
	}
}

/* ------------------------------------------------------------------------ */
void DrawMap (void)
/* ------------------------------------------------------------------------ */
{
int x, y;

	setcolor (GREEN);
	for (x=TOP; x<=BOTTOM; x+=10)
		line (LEFT, x, RIGHT, x);
	for (y=LEFT; y<=RIGHT; y+=10)
		line (y, TOP, y, BOTTOM);
}

/* ------------------------------------------------------------------------ */
void PutPoint (float x, float y, int color)
/* ------------------------------------------------------------------------ */
{
int dx, dy;
	if ((x >= 0) && (x <= 40) && (y >= 0) && (y <= 40))
		for (dx=-2; dx<=2; dx++)
			for (dy=-2; dy<=2; dy++)
				putpixel (LEFT + x*10 + dx, BOTTOM - y*10 + dy, color);
}

/* ------------------------------------------------------------------------ */
void RandomCities (int N)
/* ------------------------------------------------------------------------ */
{
int i, x, y;
FILE *f;

	f = fopen("patterns.in","w");
	randomize ();
	for (i=0; i<N; i++)
	{
		x = random(41);
		y = random(41);
		PutPoint (x, y, LIGHTRED);
		fprintf(f,"%f\n",(float)x);
		fprintf(f,"%f\n",(float)y);
	}
	fclose(f);
}

/* ------------------------------------------------------------------------ */
void main (int argc, char *argv[])
/* ------------------------------------------------------------------------ */
{
int N;

	if (argc != 2)
	{
		printf ("Uso: init <Nmero de ciudades>\n");
		exit (1);
	}

	ResetScreen ();
	DrawMap ();
	N = atoi(argv[1]);
	RandomCities (N);
	getch ();
	closegraph ();
}

